// flex size mixins
._mixin_flex (@padding,@offset) {
    margin: @offset;
    & > * {
        padding: @padding;
    }
}

._mixin_flex_x (@padding,@offset) {
    margin-left: @offset;
    margin-right: @offset;
    & > * {
        padding-left: @padding;
        padding-right: @padding;
    }
}

._mixin_flex_y (@padding,@offset) {
    margin-top: @offset;
    margin-bottom: @offset;
    & > * {
        padding-top: @padding;
        padding-bottom: @padding;
    }
}

// flex offset mixins

._mixin_flex_o(@offset) {
    margin: @offset;
}

._mixin_flex_ox(@offset) {
    margin-left: @offset;
    margin-right: @offset;
}

._mixin_flex_oy(@offset) {
    margin-top: @offset;
    margin-bottom: @offset;
}

// flex sizes

.flex_xs {
    ._mixin_flex(@flex-padding_xs, @flex-offset_xs)
}

.flex_s {
    ._mixin_flex(@flex-padding_s, @flex-offset_s)
}

.flex_m {
    ._mixin_flex(@flex-padding_m, @flex-offset_m)
}

.flex_l {
    ._mixin_flex(@flex-padding_l, @flex-offset_l)
}

.flex_xl {
    ._mixin_flex(@flex-padding_xl, @flex-offset_xl)
}

.flex_xxl {
    ._mixin_flex(@flex-padding_xxl, @flex-offset_xxl)
}

.flex_x2 {
    ._mixin_flex(@flex-padding_x2, @flex-offset_x2)
}

.flex_x3 {
    ._mixin_flex(@flex-padding_x3, @flex-offset_x3)
}

//flex horisontal spacing

.flex_x_xs {
    ._mixin_flex_x(@flex-padding_xs, @flex-offset_xs)
}

.flex_x_s {
    ._mixin_flex_x(@flex-padding_s, @flex-offset_s)
}

.flex_x_m {
    ._mixin_flex_x(@flex-padding_m, @flex-offset_m)
}

.flex_x_l {
    ._mixin_flex_x(@flex-padding_l, @flex-offset_l)
}

.flex_x_xl {
    ._mixin_flex_x(@flex-padding_xl, @flex-offset_xl)
}

.flex_x_xxl {
    ._mixin_flex_x(@flex-padding_xxl, @flex-offset_xxl)
}

.flex_x_x2 {
    ._mixin_flex_x(@flex-padding_x2, @flex-offset_x2)
}

.flex_x_x3 {
    ._mixin_flex_x(@flex-padding_x3, @flex-offset_x3)
}

//flex vertical spacing

.flex_y_xs {
    ._mixin_flex_y(@flex-padding_xs, @flex-offset_xs)
}

.flex_y_s {
    ._mixin_flex_y(@flex-padding_s, @flex-offset_s)
}

.flex_y_m {
    ._mixin_flex_y(@flex-padding_m, @flex-offset_m)
}

.flex_y_l {
    ._mixin_flex_y(@flex-padding_l, @flex-offset_l)
}

.flex_y_xl {
    ._mixin_flex_y(@flex-padding_xl, @flex-offset_xl)
}

.flex_y_xxl {
    ._mixin_flex_y(@flex-padding_xxl, @flex-offset_xxl)
}

.flex_y_x2 {
    ._mixin_flex_y(@flex-padding_x2, @flex-offset_x2)
}

.flex_y_x3 {
    ._mixin_flex_y(@flex-padding_x3, @flex-offset_x3)
}

// flex offset

.flex_o_xs {
    ._mixin_flex_o(@flex-offset_xs)
}

.flex_o_s {
    ._mixin_flex_o(@flex-offset_s)
}

.flex_o_m {
    ._mixin_flex_o(@flex-offset_m);
}

.flex_o_l {
    ._mixin_flex_o(@flex-offset_l)
}

.flex_o_xl {
    ._mixin_flex_o(@flex-offset_xl)
}

.flex_o_xxl {
    ._mixin_flex_o(@flex-offset_xxl)
}

// flex offset horizontal

.flex_ox_xs {
    ._mixin_flex_ox(@flex-offset_xs)
}

.flex_ox_s {
    ._mixin_flex_ox(@flex-offset_s)
}

.flex_ox_m {
    ._mixin_flex_ox(@flex-offset_m);
}

.flex_ox_l {
    ._mixin_flex_ox(@flex-offset_l)
}

.flex_ox_xl {
    ._mixin_flex_ox(@flex-offset_xl)
}

.flex_ox_xxl {
    ._mixin_flex_ox(@flex-offset_xxl)
}

// flex offset vertical

.flex_oy_xs {
    ._mixin_flex_oy(@flex-offset_xs)
}

.flex_oy_s {
    ._mixin_flex_oy(@flex-offset_s)
}

.flex_oy_m {
    ._mixin_flex_oy(@flex-offset_m);
}

.flex_oy_l {
    ._mixin_flex_oy(@flex-offset_l)
}

.flex_oy_xl {
    ._mixin_flex_oy(@flex-offset_xl)
}

.flex_oy_xxl {
    ._mixin_flex_oy(@flex-offset_xxl)
}

//flex core

.flex {
    display: flex;
}

.flex_inline {
    display: inline-flex;
}

.flex_column {
    flex-direction: column;
}

.flex_wrap {
    flex-wrap: wrap;
}

.flex-item_1 {
    flex:1 1 auto;
}

.flex-item_0 {
    flex:0 0 auto;
}

.flex_center {
    justify-content: center;
    align-items: center;
}

//flex items

.flex_1 {
    & > * {
        width: 100%/1;
    }
}

.flex_2 {
    & > * {
        width: 100%/2;
    }
}

.flex_3 {
    & > * {
        width: 100%/3;
    }
}

.flex_4 {
    & > * {
        width: 100%/4;
    }
}

.flex_5 {
    & > * {
        width: 100%/5;
    }
}

.flex_6 {
    & > * {
        width: 100%/6;
    }
}

.flex_7 {
    & > * {
        width: 100%/7;
    }
}

.flex_8 {
    & > * {
        width: 100%/8;
    }
}

.flex_9 {
    & > * {
        width: 100%/9;
    }
}

.flex_10 {
    & > * {
        width: 100%/10;
    }
}

.flex_11 {
    & > * {
        width: 100%/11;
    }
}

.flex_12 {
    & > * {
        width: 100%/12;
    }
}

.flex_6-5 {
    & > * {
        width: 100%/6;
        &:nth-child(11n-4) {
            margin-left: 100%/6/2;
        }
    }
}

.flex_5-4 {
    & > * {
        width: 100%/5;
        &:nth-child(9n-3) {
            margin-left: 100%/5/2;
        }
    }
}
.flex_4-3 {
    & > * {
        width: 100%/4;
        &:nth-child(7n-2) {
            margin-left: 100%/4/2;
        }
    }
}

.flex_3-2 {
    & > * {
        width: 100%/3;
        &:nth-child(5n-1) {
            margin-left: 100%/3/2;
        }
    }
}
